# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API.

    The version of the OpenAPI document: 0.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1_data_source_autoloader_spec import CoreV1DataSourceAutoloaderSpec
from dasl_api.models.core_v1_data_source_spec_bronze import CoreV1DataSourceSpecBronze
from dasl_api.models.core_v1_data_source_spec_custom import CoreV1DataSourceSpecCustom
from dasl_api.models.core_v1_data_source_spec_gold import CoreV1DataSourceSpecGold
from dasl_api.models.core_v1_data_source_spec_silver import CoreV1DataSourceSpecSilver
from dasl_api.models.core_v1_schedule import CoreV1Schedule
from typing import Optional, Set
from typing_extensions import Self

class CoreV1DataSourceSpec(BaseModel):
    """
    CoreV1DataSourceSpec
    """ # noqa: E501
    source: Optional[StrictStr] = Field(default=None, description="The name of originator of the data we will import (GCP, AWS, Okta, etc).")
    source_type: Optional[StrictStr] = Field(default=None, description="The type of data we are importing from the source (e.g. S3, LB, etc).", alias="sourceType")
    schedule: Optional[CoreV1Schedule] = None
    custom: Optional[CoreV1DataSourceSpecCustom] = None
    use_preset: Optional[StrictStr] = Field(default=None, description="The name of the preset to use for this data source. ", alias="usePreset")
    autoloader: Optional[CoreV1DataSourceAutoloaderSpec] = Field(default=None, description="Describes how to import data into the bronze table(s) overriding the chosen preset autoloader. ")
    bronze: Optional[CoreV1DataSourceSpecBronze] = None
    silver: Optional[CoreV1DataSourceSpecSilver] = None
    gold: Optional[CoreV1DataSourceSpecGold] = None
    __properties: ClassVar[List[str]] = ["source", "sourceType", "schedule", "custom", "usePreset", "autoloader", "bronze", "silver", "gold"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CoreV1DataSourceSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of schedule
        if self.schedule:
            _dict['schedule'] = self.schedule.to_dict()
        # override the default output from pydantic by calling `to_dict()` of custom
        if self.custom:
            _dict['custom'] = self.custom.to_dict()
        # override the default output from pydantic by calling `to_dict()` of autoloader
        if self.autoloader:
            _dict['autoloader'] = self.autoloader.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bronze
        if self.bronze:
            _dict['bronze'] = self.bronze.to_dict()
        # override the default output from pydantic by calling `to_dict()` of silver
        if self.silver:
            _dict['silver'] = self.silver.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gold
        if self.gold:
            _dict['gold'] = self.gold.to_dict()
        # set to None if source (nullable) is None
        # and model_fields_set contains the field
        if self.source is None and "source" in self.model_fields_set:
            _dict['source'] = None

        # set to None if source_type (nullable) is None
        # and model_fields_set contains the field
        if self.source_type is None and "source_type" in self.model_fields_set:
            _dict['sourceType'] = None

        # set to None if custom (nullable) is None
        # and model_fields_set contains the field
        if self.custom is None and "custom" in self.model_fields_set:
            _dict['custom'] = None

        # set to None if use_preset (nullable) is None
        # and model_fields_set contains the field
        if self.use_preset is None and "use_preset" in self.model_fields_set:
            _dict['usePreset'] = None

        # set to None if autoloader (nullable) is None
        # and model_fields_set contains the field
        if self.autoloader is None and "autoloader" in self.model_fields_set:
            _dict['autoloader'] = None

        # set to None if bronze (nullable) is None
        # and model_fields_set contains the field
        if self.bronze is None and "bronze" in self.model_fields_set:
            _dict['bronze'] = None

        # set to None if silver (nullable) is None
        # and model_fields_set contains the field
        if self.silver is None and "silver" in self.model_fields_set:
            _dict['silver'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CoreV1DataSourceSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "source": obj.get("source"),
            "sourceType": obj.get("sourceType"),
            "schedule": CoreV1Schedule.from_dict(obj["schedule"]) if obj.get("schedule") is not None else None,
            "custom": CoreV1DataSourceSpecCustom.from_dict(obj["custom"]) if obj.get("custom") is not None else None,
            "usePreset": obj.get("usePreset"),
            "autoloader": CoreV1DataSourceAutoloaderSpec.from_dict(obj["autoloader"]) if obj.get("autoloader") is not None else None,
            "bronze": CoreV1DataSourceSpecBronze.from_dict(obj["bronze"]) if obj.get("bronze") is not None else None,
            "silver": CoreV1DataSourceSpecSilver.from_dict(obj["silver"]) if obj.get("silver") is not None else None,
            "gold": CoreV1DataSourceSpecGold.from_dict(obj["gold"]) if obj.get("gold") is not None else None
        })
        return _obj


