# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API.

    The version of the OpenAPI document: 0.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1_rule_spec_input_batch import CoreV1RuleSpecInputBatch
from dasl_api.models.core_v1_rule_spec_input_stream import CoreV1RuleSpecInputStream
from typing import Optional, Set
from typing_extensions import Self

class CoreV1RuleSpecInput(BaseModel):
    """
    CoreV1RuleSpecInput
    """ # noqa: E501
    stream: Optional[CoreV1RuleSpecInputStream] = None
    batch: Optional[CoreV1RuleSpecInputBatch] = None
    __properties: ClassVar[List[str]] = ["stream", "batch"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CoreV1RuleSpecInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of stream
        if self.stream:
            _dict['stream'] = self.stream.to_dict()
        # override the default output from pydantic by calling `to_dict()` of batch
        if self.batch:
            _dict['batch'] = self.batch.to_dict()
        # set to None if stream (nullable) is None
        # and model_fields_set contains the field
        if self.stream is None and "stream" in self.model_fields_set:
            _dict['stream'] = None

        # set to None if batch (nullable) is None
        # and model_fields_set contains the field
        if self.batch is None and "batch" in self.model_fields_set:
            _dict['batch'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CoreV1RuleSpecInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "stream": CoreV1RuleSpecInputStream.from_dict(obj["stream"]) if obj.get("stream") is not None else None,
            "batch": CoreV1RuleSpecInputBatch.from_dict(obj["batch"]) if obj.get("batch") is not None else None
        })
        return _obj


