# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API.

    The version of the OpenAPI document: 0.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1_rule_spec_metadata_response_playbooks_inner import CoreV1RuleSpecMetadataResponsePlaybooksInner
from typing import Optional, Set
from typing_extensions import Self

class CoreV1RuleSpecMetadataResponse(BaseModel):
    """
    CoreV1RuleSpecMetadataResponse
    """ # noqa: E501
    guidelines: Optional[StrictStr] = None
    playbooks: Optional[List[CoreV1RuleSpecMetadataResponsePlaybooksInner]] = None
    __properties: ClassVar[List[str]] = ["guidelines", "playbooks"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CoreV1RuleSpecMetadataResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in playbooks (list)
        _items = []
        if self.playbooks:
            for _item_playbooks in self.playbooks:
                if _item_playbooks:
                    _items.append(_item_playbooks.to_dict())
            _dict['playbooks'] = _items
        # set to None if guidelines (nullable) is None
        # and model_fields_set contains the field
        if self.guidelines is None and "guidelines" in self.model_fields_set:
            _dict['guidelines'] = None

        # set to None if playbooks (nullable) is None
        # and model_fields_set contains the field
        if self.playbooks is None and "playbooks" in self.model_fields_set:
            _dict['playbooks'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CoreV1RuleSpecMetadataResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "guidelines": obj.get("guidelines"),
            "playbooks": [CoreV1RuleSpecMetadataResponsePlaybooksInner.from_dict(_item) for _item in obj["playbooks"]] if obj.get("playbooks") is not None else None
        })
        return _obj


