# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API.

    The version of the OpenAPI document: 0.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class DbuiV1ObservableInstanceRisk(BaseModel):
    """
    DbuiV1ObservableInstanceRisk
    """ # noqa: E501
    notable_impact: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="notableImpact")
    notable_confidence: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="notableConfidence")
    score_last24h: Union[StrictFloat, StrictInt] = Field(description="Contains the total summed score for this observable over the period of time beginning 24h before the first event in this notable, and ending at the last event in the notable. ", alias="scoreLast24h")
    total_score: Union[StrictFloat, StrictInt] = Field(description="Contains the total summed score for this observable over all time.", alias="totalScore")
    __properties: ClassVar[List[str]] = ["notableImpact", "notableConfidence", "scoreLast24h", "totalScore"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DbuiV1ObservableInstanceRisk from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if notable_impact (nullable) is None
        # and model_fields_set contains the field
        if self.notable_impact is None and "notable_impact" in self.model_fields_set:
            _dict['notableImpact'] = None

        # set to None if notable_confidence (nullable) is None
        # and model_fields_set contains the field
        if self.notable_confidence is None and "notable_confidence" in self.model_fields_set:
            _dict['notableConfidence'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DbuiV1ObservableInstanceRisk from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "notableImpact": obj.get("notableImpact"),
            "notableConfidence": obj.get("notableConfidence"),
            "scoreLast24h": obj.get("scoreLast24h"),
            "totalScore": obj.get("totalScore")
        })
        return _obj


