# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API.

    The version of the OpenAPI document: 0.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DbuiV1TableColumnDetails(BaseModel):
    """
    DbuiV1TableColumnDetails
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The column name.")
    type_name: Optional[StrictStr] = Field(default=None, description="The name of the column type.")
    type_detail: Optional[StrictStr] = Field(default=None, description="Additional information about the column's type.")
    position: Optional[StrictInt] = Field(default=None, description="The column's index in the table.")
    nullable: Optional[StrictBool] = Field(default=None, description="Is this column nullable.")
    __properties: ClassVar[List[str]] = ["name", "type_name", "type_detail", "position", "nullable"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DbuiV1TableColumnDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if type_name (nullable) is None
        # and model_fields_set contains the field
        if self.type_name is None and "type_name" in self.model_fields_set:
            _dict['type_name'] = None

        # set to None if type_detail (nullable) is None
        # and model_fields_set contains the field
        if self.type_detail is None and "type_detail" in self.model_fields_set:
            _dict['type_detail'] = None

        # set to None if position (nullable) is None
        # and model_fields_set contains the field
        if self.position is None and "position" in self.model_fields_set:
            _dict['position'] = None

        # set to None if nullable (nullable) is None
        # and model_fields_set contains the field
        if self.nullable is None and "nullable" in self.model_fields_set:
            _dict['nullable'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DbuiV1TableColumnDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "type_name": obj.get("type_name"),
            "type_detail": obj.get("type_detail"),
            "position": obj.get("position"),
            "nullable": obj.get("nullable")
        })
        return _obj


