# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API.

    The version of the OpenAPI document: 0.1.3
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1_data_source_autoloader_spec import CoreV1DataSourceAutoloaderSpec
from dasl_api.models.dbui_v1_transform_request_input import DbuiV1TransformRequestInput
from dasl_api.models.dbui_v1_transform_request_transforms_inner import DbuiV1TransformRequestTransformsInner
from typing import Optional, Set
from typing_extensions import Self

class DbuiV1TransformRequest(BaseModel):
    """
    The transform request identifies the starting data (either with an autoloader spec or an input block) and then identifies a chain of transforms to be performed on the data. The return type includes the data at each intermediate stage (e.g. it returns the input or autoloaded data, and the pre-transform, and the silver) 
    """ # noqa: E501
    input: Optional[DbuiV1TransformRequestInput] = None
    autoloader_input: Optional[CoreV1DataSourceAutoloaderSpec] = Field(default=None, alias="autoloaderInput")
    use_preset: Optional[StrictStr] = Field(default=None, description="indicates which preset to use for the transforms", alias="usePreset")
    transforms: List[DbuiV1TransformRequestTransformsInner]
    __properties: ClassVar[List[str]] = ["input", "autoloaderInput", "usePreset", "transforms"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DbuiV1TransformRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of input
        if self.input:
            _dict['input'] = self.input.to_dict()
        # override the default output from pydantic by calling `to_dict()` of autoloader_input
        if self.autoloader_input:
            _dict['autoloaderInput'] = self.autoloader_input.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in transforms (list)
        _items = []
        if self.transforms:
            for _item_transforms in self.transforms:
                if _item_transforms:
                    _items.append(_item_transforms.to_dict())
            _dict['transforms'] = _items
        # set to None if input (nullable) is None
        # and model_fields_set contains the field
        if self.input is None and "input" in self.model_fields_set:
            _dict['input'] = None

        # set to None if autoloader_input (nullable) is None
        # and model_fields_set contains the field
        if self.autoloader_input is None and "autoloader_input" in self.model_fields_set:
            _dict['autoloaderInput'] = None

        # set to None if use_preset (nullable) is None
        # and model_fields_set contains the field
        if self.use_preset is None and "use_preset" in self.model_fields_set:
            _dict['usePreset'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DbuiV1TransformRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "input": DbuiV1TransformRequestInput.from_dict(obj["input"]) if obj.get("input") is not None else None,
            "autoloaderInput": CoreV1DataSourceAutoloaderSpec.from_dict(obj["autoloaderInput"]) if obj.get("autoloaderInput") is not None else None,
            "usePreset": obj.get("usePreset"),
            "transforms": [DbuiV1TransformRequestTransformsInner.from_dict(_item) for _item in obj["transforms"]] if obj.get("transforms") is not None else None
        })
        return _obj


